//lbzs.cs
datablock AudioProfile(lbzsHitSound)
{
   filename    = "./lbzshit.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(lbzsstartSound)
{
   filename    = "./lbzsstart.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(lbzsfireSound)
{
   filename    = "./lbzsfire.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(lbzsdoneSound)
{
   filename    = "./lbzsdone.wav";
   description = AudioClosest3d;
   preload = true;
};

//effects
datablock ParticleData(lbzsExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.5;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   spinRandomMin = -90;
   spinRandomMax = 90;
   lifetimeMS           = 200;
   lifetimeVarianceMS   = 100;
   textureName          = "base/data/particles/dot";
   colors[0]     = "0.4 0.2 0.1 1.0";
   colors[1]     = "0.4 0.2 0.1 1.0";
   sizes[0]      = 0.10;
   sizes[1]      = 0.15;
};

datablock ParticleEmitterData(lbzsExplosionEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 3;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "lbzsExplosionParticle";

   uiName = "LEGO Buzz Saw Hit";
};

datablock ExplosionData(lbzsExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   soundProfile = lbzsHitSound;

   particleEmitter = lbzsExplosionEmitter;
   particleDensity = 3;
   particleRadius = 0.1;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 0;
   lightStartColor = "0.4 0.2 0.1 0.9";
   lightEndColor = "0 0 0";
};


//projectile
AddDamageType("lbzs",   '<bitmap:add-ons/Weapon_Legoswextramelee/CI_lbzs> %1',    '%2 <bitmap:add-ons/Weapon_Legoswextramelee/CI_lbzs> %1',0.75,1);
datablock ProjectileData(lbzsProjectile)
{
   directDamage        = 5;
   directDamageType  = $DamageType::lbzs;
   radiusDamageType  = $DamageType::lbzs;
   explosion           = lbzsExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "LEGO Buzz Saw Slice";
};


//////////
// item //
//////////
datablock ItemData(lbzsItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./lbzs.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "LEGO Buzz Saw";
	iconName = "./icon_lbzs";
	doColorShift = true;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = lbzsImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(lbzsImage)
{
   // Basic Item properties
   shapeFile = "./lbzs.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0.0 0.0 0.0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = lbzsItem;
   ammo = " ";
   projectile = lbzsProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateSequence[3]                = "Stop";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.6;
	stateSound[2]                    = lbzsstartSound;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.05;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;
	stateSound[3]                    = lbzsfireSound;

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.8;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSound[5]                    = lbzsdoneSound;

};