//les.cs

datablock AudioProfile(lesDrawSound)
{
   filename    = "./lesstart.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(lesHitSound)
{
   filename    = "./lesHit.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(lesLoopSound)
{
   filename    = "./lesloop.wav";
   description = AudioCloseLooping3d;
   preload = true;
};

datablock AudioProfile(lesswingSound)
{
   filename    = "./lesswing.wav";
   description = AudioCloseLooping3d;
   preload = true;
};

//effects

datablock ParticleData(lesExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   spinRandomMin = 0;
   spinRandomMax = 0;
   lifetimeMS           = 100;
   lifetimeVarianceMS   = 0.0;
   textureName          = "./lightning";
   colors[0]     = "0.8 0.1 1.0 0.9";
   colors[1]     = "0.8 0.1 1.0 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 0.3;
};

datablock ParticleEmitterData(lesExplosionEmitter)
{
   ejectionPeriodMS = 100;
   periodVarianceMS = 3;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "lesExplosionParticle";

   uiName = "LEGO Electrostaff Explosion";
};

datablock ExplosionData(lesExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 300;

   soundProfile = lesHitSound;

   particleEmitter = lesExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.5;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 0;
   lightStartColor = "0.8 0.1 1.0 0.8";
   lightEndColor = "0.8 0.1 1.0 0.5";
};


//projectile
AddDamageType("les",   '<bitmap:add-ons/Weapon_Legoswextramelee/CI_les> %1',    '%2 <bitmap:add-ons/Weapon_Legoswextramelee/CI_les> %1',0.75,1);
datablock ProjectileData(lesProjectile)
{
   directDamage        = 20;
   directDamageType  = $DamageType::les;
   radiusDamageType  = $DamageType::les;
   explosion           = lesExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "0.8 0.1 1.0 0.5";

   uiName = "LEGO Electrostaff Slice";
};


//////////
// item //
//////////
datablock ItemData(lesItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./les.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "LEGO Electrostaff";
	iconName = "./icon_les";
	doColorShift = false;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = lesImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(lesImage)
{
   // Basic Item properties
   shapeFile = "./les.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = lesItem;
   ammo = " ";
   projectile = lesProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateSequence[0]                = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]                    = lesDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateSound[1]			 = lesLoopSound;
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = true;
	stateTimeoutValue[2]            = 0.01;
	stateTransitionOnTimeout[2]     = "Fire";
	stateSound[2]			 = lesLoopSound;

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Fire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = true;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateSound[3]			 = lesswingSound;
	stateWaitForTimeout[3]			= true;
	stateSequence[3]				= "Fire";
   stateTransitionOnTriggerUp[3]	= "StopFire";
	//stateTransitionOnTriggerUp[3]	= "StopFire";

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";
	stateSound[4]			 = lesLoopSound;

	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = true;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                 = "onStopFire";
	stateSound[5]			 = lesLoopSound;

};

function lesImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
	//messageAll( 'MsgClient', 'stopfire');
}

function lesImage::onFire(%this, %obj, %slot)
	{

	//messageAll( 'MsgClient', 'les prefired!!!');
	Parent::onFire(%this, %obj, %slot);
	%obj.playthread(2, rotCW);

		%fvec = %obj.getForwardVector();
		%fX = getWord(%fvec,0);
		%fY = getWord(%fvec,1);
		
		%evec = %obj.getEyeVector();
		%eX = getWord(%evec,0);
		%eY = getWord(%evec,1);
		%eZ = getWord(%evec,2);
		
		%eXY = mSqrt(%eX*%eX+%eY*%eY);
		
		%aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;
		
		initContainerRadiusSearch(%obj.getEyePoint(),getWord(%obj.getScale(),2)*2,$TypeMasks::ProjectileObjectType);
		while(isObject(firstWord(%searchObj = containerSearchNext())))
		{
			//If the projectile isn't in your minigame, don't reflect it
			if(!miniGameCanDamage(%searchObj,%obj))
				continue;
			
			//If the projectile has no velocity, don't reflect it
			if(vectorLen(%searchObj.getVelocity()) == 0 || %searchObj.dataBlock.lifeTime <= 0)
				continue;
			
			//If the projectile came from behind you, don't reflect it
			%vel = vectorNormalize(%searchObj.getVelocity());
			if(vectorDot(%aimVec,%vel) > 0.707)
				continue;
			
			
			//"Push" effect
			%scaleFactor = getWord(%obj.getScale(), 2);
			%data = lesProjectile;
			%p = new Projectile()
			{
				dataBlock = %data;
				initialPosition = %pos;
				initialVelocity = %obj.getMuzzleVector(0);
				sourceObject = %obj;
				client = %obj.client;
				sourceSlot = 0;
				originPoint = %pos;
			};
			%p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
			%p.explode();
			
			%searchObj.delete();
		}
		Parent::onFire(%this, %obj, %slot);
}

function lesProjectile::damage(%this, %obj, %col, %fade, %pos, %normal)
{
	if(%col.getClassName() $= "Player" || %col.getClassName() $= "AIPlayer")
	{
		%col.setWhiteOut(1);
	}
parent::damage(%this, %obj, %col, %fade, %pos, %normal);

   if(%this.directDamage <= 0)
      return;

   %damageType = $DamageType::Direct;
   if(%this.DirectDamageType)
      %damageType = %this.DirectDamageType;

   %scale = getWord(%obj.getScale(), 2);
   %directDamage = mClampF(%this.directDamage, 0, 0) * %scale;

   if(%col.getType() & $TypeMasks::PlayerObjectType)
   {
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }
   else
   {
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }	
}