//lfp.cs
datablock AudioProfile(lfpHitSound)
{
   filename    = "./lefhit.wav";
   description = AudioClosest3d;
   preload = true;
};


//effects
datablock ParticleData(lfpExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = -0.5;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   spinRandomMin = -90;
   spinRandomMax = 90;
   lifetimeMS           = 300;
   lifetimeVarianceMS   = 200;
   textureName          = "base/data/particles/cloud";
   colors[0]     = "0.4 0.2 0.1 0.9";
   colors[1]     = "0.4 0.2 0.1 0.9";
   sizes[0]      = 0.30;
   sizes[1]      = 0.50;
};

datablock ParticleEmitterData(lfpExplosionEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 3;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "lfpExplosionParticle";

   uiName = "LEGO Force Pike Hit";
};

datablock ExplosionData(lfpExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   soundProfile = lfpHitSound;

   particleEmitter = lfpExplosionEmitter;
   particleDensity = 3;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 0;
   lightStartColor = "0.4 0.2 0.1 0.9";
   lightEndColor = "0 0 0";
};


//projectile
AddDamageType("lfp",   '<bitmap:add-ons/Weapon_Legoswextramelee/CI_lfp> %1',    '%2 <bitmap:add-ons/Weapon_Legoswextramelee/CI_lfp> %1',0.75,1);
datablock ProjectileData(lfpProjectile)
{
   directDamage        = 40;
   directDamageType  = $DamageType::lfp;
   radiusDamageType  = $DamageType::lfp;
   explosion           = lfpExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "LEGO Force Pike Slice";
};


//////////
// item //
//////////
datablock ItemData(lfpItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./lfp.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "LEGO Force Pike";
	iconName = "./icon_lfp";
	doColorShift = true;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = lfpImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(lfpImage)
{
   // Basic Item properties
   shapeFile = "./lfp.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0.0 0.0 0.0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = lfpItem;
   ammo = " ";
   projectile = lfpProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "StopFire";

	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Firepause";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";

	stateName[6]                    = "Firepause";
	stateTransitionOnTimeout[6]     = "Ready";
	stateTimeoutValue[6]            = 1.0;

};

function lfpImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
	Parent::onPreFire(%this,%obj,%slot);
}

function lfpImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
	Parent::onStopFire(%this,%obj,%slot);
}

function lfpProjectile::damage(%this, %obj, %col, %fade, %pos, %normal)
{
	if(%col.getClassName() $= "Player" || %col.getClassName() $= "AIPlayer")
	{
		tumble(%col, 5000);
	}
parent::damage(%this, %obj, %col, %fade, %pos, %normal);

   if(%this.directDamage <= 0)
      return;

   %damageType = $DamageType::Direct;
   if(%this.DirectDamageType)
      %damageType = %this.DirectDamageType;

   %scale = getWord(%obj.getScale(), 2);
   %directDamage = mClampF(%this.directDamage, 0, 0) * %scale;

   if(%col.getType() & $TypeMasks::PlayerObjectType)
   {
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }
   else
   {
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }	
}

function lfpImage::onFire(%this, %obj, %slot)
	{
		%fvec = %obj.getForwardVector();
		%fX = getWord(%fvec,0);
		%fY = getWord(%fvec,1);
		
		%evec = %obj.getEyeVector();
		%eX = getWord(%evec,0);
		%eY = getWord(%evec,1);
		%eZ = getWord(%evec,2);
		
		%eXY = mSqrt(%eX*%eX+%eY*%eY);
		
		%aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;
		
		initContainerRadiusSearch(%obj.getEyePoint(),getWord(%obj.getScale(),2)*2,$TypeMasks::ProjectileObjectType);
		while(isObject(firstWord(%searchObj = containerSearchNext())))
		{
			//If the projectile isn't in your minigame, don't reflect it
			if(!miniGameCanDamage(%searchObj,%obj))
				continue;
			
			//If the projectile has no velocity, don't reflect it
			if(vectorLen(%searchObj.getVelocity()) == 0 || %searchObj.dataBlock.lifeTime <= 0)
				continue;
			
			//If the projectile came from behind you, don't reflect it
			%vel = vectorNormalize(%searchObj.getVelocity());
			if(vectorDot(%aimVec,%vel) > 0.707)
				continue;
			
			//"Push" effect
			%scaleFactor = getWord(%obj.getScale(), 2);
			%data = lfpProjectile;
			%p = new Projectile()
			{
				dataBlock = %data;
				initialPosition = %pos;
				initialVelocity = %obj.getMuzzleVector(0);
				sourceObject = %obj;
				client = %obj.client;
				sourceSlot = 0;
				originPoint = %pos;
			};
			%p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
			%p.explode();
			
			%searchObj.delete();
		}
		Parent::onFire(%this, %obj, %slot);
}